// 
// lat - GtkLdapServerInfo.cs
// Author: Loren Bandiera
// Copyright 2005 MMG Security, Inc.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; Version 2 .
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//

using System;
using Gtk;

namespace lat
{	
	public class GtkLdapServerInfo : Gtk.Bin
	{
		protected Gtk.ListStore store;
		protected Gtk.TreeView treeview1;
		
		
		public GtkLdapServerInfo()
		{
			Stetic.Gui.Build(this, typeof(lat.GtkLdapServerInfo));
			
			store = new Gtk.ListStore (typeof (string), typeof (string));
			treeview1.Model = store;
			
			treeview1.AppendColumn ("Name", new CellRendererText (), "text", 0); 
			treeview1.AppendColumn ("Value", new CellRendererText (), "text", 1); 			
		}
		
		public Connection CurrentConnection
		{
			set {
				store.Clear ();

				store.AppendValues (Mono.Unix.Catalog.GetString ("Host"), value.Settings.Host);
				store.AppendValues (Mono.Unix.Catalog.GetString ("Port"), value.Settings.Port.ToString());
				store.AppendValues (Mono.Unix.Catalog.GetString ("User"), value.AuthDN);
				store.AppendValues (Mono.Unix.Catalog.GetString ("Base DN"), value.DirectoryRoot);
				store.AppendValues (Mono.Unix.Catalog.GetString ("Connected"), value.IsConnected.ToString());
				store.AppendValues (Mono.Unix.Catalog.GetString ("Bound"), value.IsBound.ToString());
				store.AppendValues (Mono.Unix.Catalog.GetString ("TLS/SSL"), value.UseSSL.ToString());
				store.AppendValues (Mono.Unix.Catalog.GetString ("Protocol Version"), value.Protocol.ToString());

				if (value.Settings.ServerType == LdapServerType.ActiveDirectory) {
					store.AppendValues (Mono.Unix.Catalog.GetString ("DNS Host Name"), value.ActiveDirectory.DnsHostName);
					store.AppendValues (Mono.Unix.Catalog.GetString ("Domain Controller Functionality"), value.ActiveDirectory.DomainControllerFunctionality);
					store.AppendValues (Mono.Unix.Catalog.GetString ("Forest Functionality"), value.ActiveDirectory.ForestFunctionality);
					store.AppendValues (Mono.Unix.Catalog.GetString ("Domain Functionality"), value.ActiveDirectory.DomainFunctionality);
					store.AppendValues (Mono.Unix.Catalog.GetString ("Global Catalog Ready"), value.ActiveDirectory.IsGlobalCatalogReady.ToString());
					store.AppendValues (Mono.Unix.Catalog.GetString ("Synchronized"), value.ActiveDirectory.IsSynchronized.ToString());
				}
			}
		}
	}
}
