// 
// lat - SelectContainerDialog.cs
// Author: Loren Bandiera
// Copyright 2005-2006 MMG Security, Inc.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; Version 2 
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//

using Gtk;
using System;

namespace lat
{	
	public class SelectContainerDialog : Gtk.Dialog
	{
		string containerDN;
		
		protected Gtk.Label msgLabel;
		protected lat.GtkLdapBrowser ldapBrowser;

		
		public SelectContainerDialog(Connection conn)
		{
			Stetic.Gui.Build(this, typeof(lat.SelectContainerDialog));
			
			ldapBrowser.BrowserSelectionMethod = (int)Preferences.Get (Preferences.BROWSER_SELECTION);
			ldapBrowser.CurrentConnection = conn;

			this.Resize (350, 400);
//			this.Icon = Global.AppIcon;
		}

		public string DN
		{
			get { return containerDN; }
		}
			
		public string Message
		{
			set { msgLabel.Markup = String.Format ("<span size=\"larger\">{0}</span>", value); }
		}

		protected virtual void OnEntrySelected(object o, lat.LdapEntrySelectedEventArgs args)
		{
			if (args.IsHost)
				return;
				
			containerDN = args.DN;
		}

		protected virtual void OnOkClicked(object sender, System.EventArgs e)
		{
			containerDN = ldapBrowser.SelectedEntry;
		}
	}
}
